import { existsSync } from 'node:fs'
import { resolve as tsNodeResolve } from 'ts-node/esm'
export { load, getFormat, transformSource }  from 'ts-node/esm'

const zodPath = [
    new URL('../node_modules/zod', import.meta.url),
    new URL('./zod.mjs', import.meta.url),
].find(existsSync)

if (zodPath === undefined) {
    throw new Error("Can't find zod")
}

export async function resolve(specifier, context, nextResolve) {
    if (specifier === 'zod') {
        return nextResolve(zodPath.href)
    }
    return tsNodeResolve(specifier, context, nextResolve)
}
