import { z, ZodType } from 'zod'

export const a = z.object({
    hello: z.function().args(z.string()),
    simpleMethod: z.function().args(z.boolean().optional()).returns(z.boolean())
})

export function iteratorResult<T>(schema: ZodType<T>) {
    return z.union([
        z.object({ done: z.literal(true) }),
        z.object({ done: z.literal(false).optional(), value: schema }),
    ])
}

export default function *hello() {
    yield 1
    // return '123'   
}

async function *gen() {
    if (Math.random() > .5) {
        await null
        yield 1
    }
    return yield "2131";
}
console.log(gen().next())
